%----
% Copyright (C) 1996, Gregor Meyer, FernUniversitaet Hagen, Germany.
% This file is part of the system 'Typical'.
% See the file LICENSE for conditions of distribution and use.
%----
%:- multifile (subtype)/1, (suptype)/1, (type)/1, (pred)/1, (type_import)/1, (local)/1.
















%
% Implementation of predicates declared in lib.pl
%
% This variant is for Eclipse

:- type_import(prolog_misc).

:- type_import(lib).

:- use_module(library(lists),[append/3,last/2,member/2,memberchk/2,nonmember/2,reverse/2,delete/3,subtract/3,subset/2]).

:- local pred nonmember(T,list(@T)).
non_member(X,L) :- nonmember(X,L).

is_list([]).
is_list([_|_]).

% deterministic append 
det_append(A,B,AB) :- append(A,B,AB). 


same_length([],[]).
same_length([_|L1],[_|L2]) :- same_length(L1,L2).
 
%-------
% remove_duplicates( LD, L ) :-
%       the list L contains every member of list LD without dup's
 
remove_duplicates([],[]).
remove_duplicates([X|Xs],Ys) :-
        member(X,Xs), !,
        remove_duplicates(Xs,Ys).
remove_duplicates([X|Xs],[X|Ys]) :-
        % not member(X,Xs),
        remove_duplicates(Xs,Ys).
 
variant(A, B) :-
        subsumes_chk(A,B),
        subsumes_chk(B,A).

